Английская Википедия:Hungarian algorithm

Материал из Онлайн справочника
Перейти к навигацииПерейти к поиску

Шаблон:Short description The Hungarian method is a combinatorial optimization algorithm that solves the assignment problem in polynomial time and which anticipated later primal–dual methods. It was developed and published in 1955 by Harold Kuhn, who gave it the name "Hungarian method" because the algorithm was largely based on the earlier works of two Hungarian mathematicians, Dénes Kőnig and Jenő Egerváry.[1][2] However, in 2006 it was discovered that Carl Gustav Jacobi had solved the assignment problem in the 19th century, and the solution had been published posthumously in 1890 in Latin.[3]

James Munkres reviewed the algorithm in 1957 and observed that it is (strongly) polynomial.[4] Since then the algorithm has been known also as the Kuhn–Munkres algorithm or Munkres assignment algorithm. The time complexity of the original algorithm was <math>O(n^4)</math>, however Edmonds and Karp, and independently Tomizawa, noticed that it can be modified to achieve an <math>O(n^3)</math> running time.[5][6] One of the most popularШаблон:Citation needed <math>O(n^3)</math> variants is the Jonker–Volgenant algorithm.[7] Ford and Fulkerson extended the method to general maximum flow problems in form of the Ford–Fulkerson algorithm.

The problem

Шаблон:Main

Example

In this simple example, there are three workers: Alice, Bob and Dora. One of them has to clean the bathroom, another sweep the floors and the third washes the windows, but they each demand different pay for the various tasks. The problem is to find the lowest-cost way to assign the jobs. The problem can be represented in a matrix of the costs of the workers doing the jobs. For example:

Шаблон:Diagonal split header Clean
bathroom
Sweep
floors
Wash
windows
Alice $8 $4 $7
Bob $5 $2 $3
Dora $9 $4 $8

The Hungarian method, when applied to the above table, would give the minimum cost: this is $15, achieved by having Alice clean the bathroom, Dora sweep the floors, and Bob wash the windows. This can be confirmed using brute force:

Шаблон:Diagonal split header Alice Bob Dora
Alice $17 $16
Bob $18 $18
Dora $15 $16
(the unassigned person washes the windows)

Matrix formulation

In the matrix formulation, we are given a nonnegative n×n matrix, where the element in the i-th row and j-th column represents the cost of assigning the j-th job to the i-th worker. We have to find an assignment of the jobs to the workers, such that each job is assigned to one worker and each worker is assigned one job, such that the total cost of assignment is minimum.

This can be expressed as permuting the rows of a cost matrix C to minimize the trace of a matrix,

<math>

\min_P \operatorname{Tr} (PC)\;, </math>

where P is a permutation matrix. (Equivalently, the columns can be permuted using CP.)

If the goal is to find the assignment that yields the maximum cost, the problem can be solved by negating the cost matrix C.

Bipartite graph formulation

The algorithm can equivalently be described by formulating the problem using a bipartite graph. We have a complete bipartite graph <math>G=(S, T; E)</math> with Шаблон:Mvar worker vertices (Шаблон:Mvar) and Шаблон:Mvar job vertices (Шаблон:Mvar), and the edges (Шаблон:Mvar) each have a nonnegative cost <math>c(i,j)</math>. We want to find a perfect matching with a minimum total cost.

The algorithm in terms of bipartite graphs

Let us call a function <math>y: (S\cup T) \to \mathbb{R}</math> a potential if <math>y(i)+y(j) \leq c(i, j)</math> for each <math>i \in S, j \in T</math>. The value of potential Шаблон:Mvar is the sum of the potential over all vertices: <math>\sum_{v\in S\cup T} y(v)</math>.

The cost of each perfect matching is at least the value of each potential: the total cost of the matching is the sum of costs of all edges; the cost of each edge is at least the sum of potentials of its endpoints; since the matching is perfect, each vertex is an endpoint of exactly one edge; hence the total cost is at least the total potential.

The Hungarian method finds a perfect matching and a potential such that the matching cost equals the potential value. This proves that both of them are optimal. In fact, the Hungarian method finds a perfect matching of tight edges: an edge <math>ij</math> is called tight for a potential Шаблон:Mvar if <math>y(i)+y(j) = c(i, j)</math>. Let us denote the subgraph of tight edges by <math>G_y</math>. The cost of a perfect matching in <math>G_y</math> (if there is one) equals the value of Шаблон:Mvar.

During the algorithm we maintain a potential Шаблон:Mvar and an orientation of <math>G_y</math> (denoted by <math>\overrightarrow{G_y}</math>) which has the property that the edges oriented from Шаблон:Mvar to Шаблон:Mvar form a matching Шаблон:Mvar. Initially, Шаблон:Mvar is 0 everywhere, and all edges are oriented from Шаблон:Mvar to Шаблон:Mvar (so Шаблон:Mvar is empty). In each step, either we modify Шаблон:Mvar so that its value increases, or modify the orientation to obtain a matching with more edges. We maintain the invariant that all the edges of Шаблон:Mvar are tight. We are done if Шаблон:Mvar is a perfect matching.

In a general step, let <math>R_S \subseteq S</math> and <math>R_T \subseteq T</math> be the vertices not covered by Шаблон:Mvar (so <math>R_S</math> consists of the vertices in Шаблон:Mvar with no incoming edge and <math>R_T</math> consists of the vertices in Шаблон:Mvar with no outgoing edge). Let Шаблон:Mvar be the set of vertices reachable in <math>\overrightarrow{G_y}</math> from <math>R_S</math> by a directed path. This can be computed by breadth-first search.

If <math>R_T \cap Z</math> is nonempty, then reverse the orientation of all edges along a directed path in <math>\overrightarrow{G_y}</math> from <math>R_S</math> to <math>R_T</math>. Thus the size of the corresponding matching increases by 1.

If <math>R_T \cap Z</math> is empty, then let

<math>\Delta := \min \{c(i,j)-y(i)-y(j): i \in Z \cap S, j \in T \setminus Z\}.</math>

Шаблон:Math is well defined because at least one such edge <math>ij</math> must exist whenever the matching is not yet of maximum possible size (see the following section); it is positive because there are no tight edges between <math>Z \cap S</math> and <math>T \setminus Z</math>. Increase Шаблон:Mvar by Шаблон:Math on the vertices of <math>Z \cap S</math> and decrease Шаблон:Mvar by Шаблон:Math on the vertices of <math>Z \cap T</math>. The resulting Шаблон:Mvar is still a potential, and although the graph <math>G_y</math> changes, it still contains Шаблон:Mvar (see the next subsections). We orient the new edges from Шаблон:Mvar to Шаблон:Mvar. By the definition of Шаблон:Math the set Шаблон:Mvar of vertices reachable from <math>R_S</math> increases (note that the number of tight edges does not necessarily increase).

We repeat these steps until Шаблон:Mvar is a perfect matching, in which case it gives a minimum cost assignment. The running time of this version of the method is <math>O(n^4)</math>: Шаблон:Mvar is augmented Шаблон:Mvar times, and in a phase where Шаблон:Mvar is unchanged, there are at most Шаблон:Mvar potential changes (since Шаблон:Mvar increases every time). The time sufficient for a potential change is <math>O(n^2)</math>.

Proof that the algorithm makes progress

We must show that as long as the matching is not of maximum possible size, the algorithm is always able to make progress — that is, to either increase the number of matched edges, or tighten at least one edge. It suffices to show that at least one of the following holds at every step:

  • Шаблон:Mvar is of maximum possible size.
  • <math>G_y</math> contains an augmenting path.
  • Шаблон:Mvar contains a loose-tailed path: a path from some vertex in <math>R_S</math> to a vertex in <math>T \setminus Z</math> that consists of any number (possibly zero) of tight edges followed by a single loose edge. The trailing loose edge of a loose-tailed path is thus from <math>Z \cap S</math>, guaranteeing that Шаблон:Math is well defined.

If Шаблон:Mvar is of maximum possible size, we are of course finished. Otherwise, by Berge's lemma, there must exist an augmenting path Шаблон:Mvar with respect to Шаблон:Mvar in the underlying graph Шаблон:Mvar. However, this path may not exist in <math>G_y</math>: Although every even-numbered edge in Шаблон:Mvar is tight by the definition of Шаблон:Mvar, odd-numbered edges may be loose and thus absent from <math>G_y</math>. One endpoint of Шаблон:Mvar is in <math>R_S</math>, the other in <math>R_T</math>; w.l.o.g., suppose it begins in <math>R_S</math>. If every edge on Шаблон:Mvar is tight, then it remains an augmenting path in <math>G_y</math> and we are done. Otherwise, let <math>uv</math> be the first loose edge on Шаблон:Mvar. If <math>v \notin Z</math> then we have found a loose-tailed path and we are done. Otherwise, Шаблон:Mvar is reachable from some other path Шаблон:Mvar of tight edges from a vertex in <math>R_S</math>. Let <math>P_v</math> be the subpath of Шаблон:Mvar beginning at Шаблон:Mvar and continuing to the end, and let <math>P'</math> be the path formed by traveling along Шаблон:Mvar until a vertex on <math>P_v</math> is reached, and then continuing to the end of <math>P_v</math>. Observe that <math>P'</math> is an augmenting path in Шаблон:Mvar with at least one fewer loose edge than Шаблон:Mvar. Шаблон:Mvar can be replaced with <math>P'</math> and this reasoning process iterated (formally, using induction on the number of loose edges) until either an augmenting path in <math>G_y</math> or a loose-tailed path in Шаблон:Mvar is found.

Proof that adjusting the potential y leaves M unchanged

To show that every edge in Шаблон:Mvar remains after adjusting Шаблон:Mvar, it suffices to show that for an arbitrary edge in Шаблон:Mvar, either both of its endpoints, or neither of them, are in Шаблон:Mvar. To this end let <math>vu</math> be an edge in Шаблон:Mvar from Шаблон:Mvar to Шаблон:Mvar. It is easy to see that if Шаблон:Mvar is in Шаблон:Mvar then Шаблон:Mvar must be too, since every edge in Шаблон:Mvar is tight. Now suppose, toward contradiction, that <math>u \in Z</math> but <math>v \notin Z</math>. Шаблон:Mvar itself cannot be in <math>R_S</math> because it is the endpoint of a matched edge, so there must be some directed path of tight edges from a vertex in <math>R_S</math> to Шаблон:Mvar. This path must avoid Шаблон:Mvar, since that is by assumption not in Шаблон:Mvar, so the vertex immediately preceding Шаблон:Mvar in this path is some other vertex <math>v' \in T</math>. <math>v'u</math> is a tight edge from Шаблон:Mvar to Шаблон:Mvar and is thus in Шаблон:Mvar. But then Шаблон:Mvar contains two edges that share the vertex Шаблон:Mvar, contradicting the fact that Шаблон:Mvar is a matching. Thus every edge in Шаблон:Mvar has either both endpoints or neither endpoint in Шаблон:Mvar.

Proof that Шаблон:Mvar remains a potential

To show that Шаблон:Mvar remains a potential after being adjusted, it suffices to show that no edge has its total potential increased beyond its cost. This is already established for edges in Шаблон:Mvar by the preceding paragraph, so consider an arbitrary edge Шаблон:Mvar from Шаблон:Mvar to Шаблон:Mvar. If <math>y(u)</math> is increased by Шаблон:Math, then either <math>v \in Z \cap T</math>, in which case <math>y(v)</math> is decreased by Шаблон:Math, leaving the total potential of the edge unchanged, or <math>v \in T \setminus Z</math>, in which case the definition of Шаблон:Math guarantees that <math>y(u)+y(v)+\Delta \leq c(u,v)</math>. Thus Шаблон:Mvar remains a potential.

The algorithm in O(n3) time

Suppose there are <math>J</math> jobs and <math>W</math> workers (<math>J\le W</math>). We describe how to compute for each prefix of jobs the minimum total cost to assign each of these jobs to distinct workers. Specifically, we add the <math>j</math>th job and update the total cost in time <math>O(jW)</math>, yielding an overall time complexity of <math>O\left(\sum_{j=1}^JjW\right)=O(J^2W)</math>. Note that this is better than <math>O(W^3)</math> when the number of jobs is small relative to the number of workers.

Adding the j-th job in O(jW) time

We use the same notation as the previous section, though we modify their definitions as necessary. Let <math>S_j</math> denote the set of the first <math>j</math> jobs and <math>T</math> denote the set of all workers.

Before the <math>j</math>th step of the algorithm, we assume that we have a matching on <math>S_{j-1}\cup T</math> that matches all jobs in <math>S_{j-1}</math> and potentials <math>y</math> satisfying the following condition: the matching is tight with respect to the potentials, and the potentials of all unmatched workers are zero, and the potentials of all matched workers are non-positive. Note that such potentials certify the optimality of the matching.

During the <math>j</math>th step, we add the <math>j</math>th job to <math>S_{j-1}</math> to form <math>S_j</math> and initialize <math>Z=\{j\}</math>. At all times, every vertex in <math>Z</math> will be reachable from the <math>j</math>th job in <math>G_y</math>. While <math>Z</math> does not contain a worker that has not been assigned a job, let

<math>\Delta := \min\{c(j, w)-y(j)-y(w):j\in Z\cap S_j, w\in T\setminus Z\}</math>

and <math>w_{\text{next}}</math> denote any <math>w</math> at which the minimum is attained. After adjusting the potentials in the way described in the previous section, there is now a tight edge from <math>Z</math> to <math>w_{\text{next}}</math>.

  • If <math>w_{\text{next}}</math> is unmatched, then we have an augmenting path in the subgraph of tight edges from <math>j</math> to <math>w_{\text{next}}</math>. After toggling the matching along this path, we have now matched the first <math>j</math> jobs, and this procedure terminates.
  • Otherwise, we add <math>w_{\text{next} }</math> and the job matched with it to <math>Z</math>.

Adjusting potentials takes <math>O(W)</math> time. Recomputing <math>\Delta</math> and <math>w_{\text{next}}</math> after changing the potentials and <math>Z</math> also can be done in <math>O(W)</math> time. Case 1 can occur at most <math>j-1</math> times before case 2 occurs and the procedure terminates, yielding the overall time complexity of <math>O(jW)</math>.

Implementation in C++

For convenience of implementation, the code below adds an additional worker <math>w_{W}</math> such that <math>y(w_{W})</math> stores the negation of the sum of all <math>\Delta</math> computed so far. After the <math>j</math>th job is added and the matching updated, the cost of the current matching equals the sum of all <math>\Delta</math> computed so far, or <math>-y(w_{W})</math>.

This code is adapted from e-maxx :: algo.[8]

/**
 * Solution to https://open.kattis.com/problems/cordonbleu using Hungarian
 * algorithm.
 */

#include <cassert>
#include <iostream>
#include <limits>
#include <vector>
using namespace std;

/**
 * Sets a = min(a, b)
 * @return true if b < a
 */
template <class T> bool ckmin(T &a, const T &b) { return b < a ? a = b, 1 : 0; }

/**
 * Given J jobs and W workers (J <= W), computes the minimum cost to assign each
 * prefix of jobs to distinct workers.
 *
 * @tparam T a type large enough to represent integers on the order of J *
 * max(|C|)
 * @param C a matrix of dimensions JxW such that C[j][w] = cost to assign j-th
 * job to w-th worker (possibly negative)
 *
 * @return a vector of length J, with the j-th entry equaling the minimum cost
 * to assign the first (j+1) jobs to distinct workers
 */
template <class T> vector<T> hungarian(const vector<vector<T>> &C) {
    const int J = (int)size(C), W = (int)size(C[0]);
    assert(J <= W);
    // job[w] = job assigned to w-th worker, or -1 if no job assigned
    // note: a W-th worker was added for convenience
    vector<int> job(W + 1, -1);
    vector<T> ys(J), yt(W + 1);  // potentials
    // -yt[W] will equal the sum of all deltas
    vector<T> answers;
    const T inf = numeric_limits<T>::max();
    for (int j_cur = 0; j_cur < J; ++j_cur) {  // assign j_cur-th job
        int w_cur = W;
        job[w_cur] = j_cur;
        // min reduced cost over edges from Z to worker w
        vector<T> min_to(W + 1, inf);
        vector<int> prv(W + 1, -1);  // previous worker on alternating path
        vector<bool> in_Z(W + 1);    // whether worker is in Z
        while (job[w_cur] != -1) {   // runs at most j_cur + 1 times
            in_Z[w_cur] = true;
            const int j = job[w_cur];
            T delta = inf;
            int w_next;
            for (int w = 0; w < W; ++w) {
                if (!in_Z[w]) {
                    if (ckmin(min_to[w], C[j][w] - ys[j] - yt[w]))
                        prv[w] = w_cur;
                    if (ckmin(delta, min_to[w])) w_next = w;
                }
            }
            // delta will always be non-negative,
            // except possibly during the first time this loop runs
            // if any entries of C[j_cur] are negative
            for (int w = 0; w <= W; ++w) {
                if (in_Z[w]) ys[job[w]] += delta, yt[w] -= delta;
                else min_to[w] -= delta;
            }
            w_cur = w_next;
        }
        // update assignments along alternating path
        for (int w; w_cur != W; w_cur = w) job[w_cur] = job[w = prv[w_cur]];
        answers.push_back(-yt[W]);
    }
    return answers;
}

/**
 * Sanity check: https://en.wikipedia.org/wiki/Hungarian_algorithm#Example
 * First job (5):
 *   clean bathroom: Bob -> 5
 * First + second jobs (9):
 *   clean bathroom: Bob -> 5
 *   sweep floors: Alice -> 4
 * First + second + third jobs (15):
 *   clean bathroom: Alice -> 8
 *   sweep floors: Dora -> 4
 *   wash windows: Bob -> 3
 */
void sanity_check_hungarian() {
    vector<vector<int>> costs{{8, 5, 9}, {4, 2, 4}, {7, 3, 8}};
    assert((hungarian(costs) == vector<int>{5, 9, 15}));
    cerr << "Sanity check passed.\n";
}

// solves https://open.kattis.com/problems/cordonbleu
void cordon_bleu() {
    int N, M;
    cin >> N >> M;
    vector<pair<int, int>> B(N), C(M);
    vector<pair<int, int>> bottles(N), couriers(M);
    for (auto &b : bottles) cin >> b.first >> b.second;
    for (auto &c : couriers) cin >> c.first >> c.second;
    pair<int, int> rest;
    cin >> rest.first >> rest.second;
    vector<vector<int>> costs(N, vector<int>(N + M - 1));
    auto dist = [&](pair<int, int> x, pair<int, int> y) {
        return abs(x.first - y.first) + abs(x.second - y.second);
    };
    for (int b = 0; b < N; ++b) {
        for (int c = 0; c < M; ++c) {  // courier -> bottle -> restaurant
            costs[b][c] =
                dist(couriers[c], bottles[b]) + dist(bottles[b], rest);
        }
        for (int _ = 0; _ < N - 1; ++_) {  // restaurant -> bottle -> restaurant
            costs[b][_ + M] = 2 * dist(bottles[b], rest);
        }
    }
    cout << hungarian(costs).back() << "\n";
}

int main() {
    sanity_check_hungarian();
    cordon_bleu();
}

Connection to successive shortest paths

The Hungarian algorithm can be seen to be equivalent to the successive shortest path algorithm for minimum cost flow,[9][10] where the reweighting technique from Johnson's algorithm is used to find the shortest paths. The implementation from the previous section is rewritten below in such a way as to emphasize this connection; it can be checked that the potentials <math>h</math> for workers <math>0\dots W-1</math> are equal to the potentials <math>y</math> from the previous solution up to a constant offset. When the graph is sparse (there are only <math>M</math> allowed job, worker pairs), it is possible to optimize this algorithm to run in <math>O(JM+J^2\log W)</math> time by using a Fibonacci heap to determine <math>w_{\text{next}}</math> instead of iterating over all <math>W</math> workers to find the one with minimum distance (alluded to here).

template <class T> vector<T> hungarian(const vector<vector<T>> &C) {
    const int J = (int)size(C), W = (int)size(C[0]);
    assert(J <= W);
    // job[w] = job assigned to w-th worker, or -1 if no job assigned
    // note: a W-th worker was added for convenience
    vector<int> job(W + 1, -1);
    vector<T> h(W);  // Johnson potentials
    vector<T> answers;
    T ans_cur = 0;
    const T inf = numeric_limits<T>::max();
    // assign j_cur-th job using Dijkstra with potentials
    for (int j_cur = 0; j_cur < J; ++j_cur) {
        int w_cur = W;  // unvisited worker with minimum distance
        job[w_cur] = j_cur;
        vector<T> dist(W + 1, inf);  // Johnson-reduced distances
        dist[W] = 0;
        vector<bool> vis(W + 1);     // whether visited yet
        vector<int> prv(W + 1, -1);  // previous worker on shortest path
        while (job[w_cur] != -1) {   // Dijkstra step: pop min worker from heap
            T min_dist = inf;
            vis[w_cur] = true;
            int w_next = -1;  // next unvisited worker with minimum distance
            // consider extending shortest path by w_cur -> job[w_cur] -> w
            for (int w = 0; w < W; ++w) {
                if (!vis[w]) {
                    // sum of reduced edge weights w_cur -> job[w_cur] -> w
                    T edge = C[job[w_cur]][w] - h[w];
                    if (w_cur != W) {
                        edge -= C[job[w_cur]][w_cur] - h[w_cur];
                        assert(edge >= 0);  // consequence of Johnson potentials
                    }
                    if (ckmin(dist[w], dist[w_cur] + edge)) prv[w] = w_cur;
                    if (ckmin(min_dist, dist[w])) w_next = w;
                }
            }
            w_cur = w_next;
        }
        for (int w = 0; w < W; ++w) {  // update potentials
            ckmin(dist[w], dist[w_cur]);
            h[w] += dist[w];
        }
        ans_cur += h[w_cur];
        for (int w; w_cur != W; w_cur = w) job[w_cur] = job[w = prv[w_cur]];
        answers.push_back(ans_cur);
    }
    return answers;
}

Matrix interpretation

Given Шаблон:Mvar workers and tasks, the problem is written in the form of an Шаблон:Mvar×Шаблон:Mvar matrix

Шаблон:Aligned table

where a, b, c and d are workers who have to perform tasks 1, 2, 3 and 4. a1, a2, a3, and a4 denote the penalties incurred when worker "a" does task 1, 2, 3, and 4 respectively.

The problem is equivalent to assigning each worker a unique task such that the total penalty is minimized. Note that each task can only be worked on by one worker.

Step 1

For each row, its minimum element is subtracted from every element in that row. This causes all elements to have non-negative values. Therefore, an assignment with a total penalty of 0 is by definition a minimum assignment.

This also leads to at least one zero in each row. As such, a naive greedy algorithm can attempt to assign all workers a task with a penalty of zero. This is illustrated below.

Шаблон:Aligned table

The zeros above would be the assigned tasks.

Worst-case there are Шаблон:Mvar! combinations to try, since multiple zeroes can appear in a row if multiple elements are the minimum. So at some point this naive algorithm should be short circuited.

Step 2

Sometimes it may turn out that the matrix at this stage cannot be used for assigning, as is the case for the matrix below.

Шаблон:Aligned table

To overcome this, we repeat the above procedure for all columns (i.e. the minimum element in each column is subtracted from all the elements in that column) and then check if an assignment with penalty 0 is possible.

In most situations this will give the result, but if it is still not possible then we need to keep going.

Step 3

All zeros in the matrix must be covered by marking as few rows and/or columns as possible. Steps 3 and 4 form one way to accomplish this.

For each row, try to assign an arbitrary zero. Assigned tasks are represented by starring a zero. Note that assignments can't be in the same row or column.

  • We assign the first zero of Row 1. The second zero of Row 1 can't be assigned.
  • We assign the first zero of Row 2. The second zero of Row 2 can't be assigned.
  • Zeros on Row 3 and Row 4 can't be assigned, because they are on the same column as the zero assigned on Row 1.

We could end with another assignment if we choose another ordering of the rows and columns.

Шаблон:Aligned table

Step 4

Cover all columns containing a (starred) zero.

× ×
0* a2 0 a4
b1 0* b3 0
0 c2 c3 c4
0 d2 d3 d4

Find a non-covered zero and prime itШаблон:Clarify. (If all zeroes are covered, skip to step 5.)

  • If the zero is on the same row as a starred zero, cover the corresponding row, and uncover the column of the starred zero.
  • Then, GOTO "Find a non-covered zero and prime it."
    • Here, the second zero of Row 1 is uncovered. Because there is another zero starred on Row 1, we cover Row 1 and uncover Column 1.
    • Then, the second zero of Row 2 is uncovered. We cover Row 2 and uncover Column 2.
×
0* a2 0' a4 ×
b1 0* b3 0
0 c2 c3 c4
0 d2 d3 d4
0* a2 0' a4 ×
b1 0* b3 0' ×
0 c2 c3 c4
0 d2 d3 d4
  • Else the non-covered zero has no assigned zero on its row. We make a path starting from the zero by performing the following steps:
    1. Substep 1: Find a starred zero on the corresponding column. If there is one, go to Substep 2, else, stop.
    2. Substep 2: Find a primed zero on the corresponding row (there should always be one). Go to Substep 1.

The zero on Row 3 is uncovered. We add to the path the first zero of Row 1, then the second zero of Row 1, then we are done.

0* a2 0' a4 ×
b1 0* b3 0' ×
0' c2 c3 c4
0 d2 d3 d4
  • (Else branch continued) For all zeros encountered during the path, star primed zeros and unstar starred zeros.
    • As the path begins and ends by a primed zero when swapping starred zeros, we have assigned one more zero.
0 a2 0* a4
b1 0* b3 0
0* c2 c3 c4
0 d2 d3 d4
  • (Else branch continued) Unprime all primed zeroes and uncover all lines.
  • Repeat the previous steps (continue looping until the above "skip to step 5" is reached).
    • We cover columns 1, 2 and 3. The second zero on Row 2 is uncovered, so we cover Row 2 and uncover Column 2:
× ×
0 a2 0* a4
b1 0* b3 0' ×
0* c2 c3 c4
0 d2 d3 d4

All zeros are now covered with a minimal number of rows and columns.

The aforementioned detailed description is just one way to draw the minimum number of lines to cover all the 0s. Other methods work as well.

Step 5

Шаблон:Confusing

Find the lowest uncovered value. Subtract this from every unmarked element and add it to every element covered by two lines.

This is equivalent to subtracting a number from all rows which are not covered and adding the same number to all columns which are covered. These operations do not change optimal assignments.

Repeat steps 4–5 until an assignment is possible; this is when the minimum number of lines used to cover all the 0s is equal to min(number of people, number of assignments), assuming dummy variables (usually the max cost) are used to fill in when the number of people is greater than the number of assignments.

If following this specific version of the algorithm, the starred zeros form the minimum assignment.

From Kőnig's theorem,[11] the minimum number of lines (minimum vertex cover[12]) will be Шаблон:Mvar (the size of maximum matching[13]). Thus, when Шаблон:Mvar lines are required, minimum cost assignment can be found by looking at only zeroes in the matrix.

Bibliography

  • R.E. Burkard, M. Dell'Amico, S. Martello: Assignment Problems (Revised reprint). SIAM, Philadelphia (PA.) 2012. Шаблон:ISBN
  • M. Fischetti, "Lezioni di Ricerca Operativa", Edizioni Libreria Progetto Padova, Italia, 1995.
  • R. Ahuja, T. Magnanti, J. Orlin, "Network Flows", Prentice Hall, 1993.
  • S. Martello, "Jeno Egerváry: from the origins of the Hungarian algorithm to satellite communication". Central European Journal of Operational Research 18, 47–58, 2010

References

Шаблон:Reflist

External links

Implementations

Note that not all of these satisfy the <math>O(n^3)</math> time complexity, even if they claim so. Some may contain errors, implement the slower <math>O(n^4)</math> algorithm, or have other inefficiencies. In the worst case, a code example linked from Wikipedia could later be modified to include exploit code. Verification and benchmarking is necessary when using such code examples from unknown authors.

Шаблон:Authority control

Шаблон:Use dmy dates

  1. Harold W. Kuhn, "The Hungarian Method for the assignment problem", Naval Research Logistics Quarterly, 2: 83–97, 1955. Kuhn's original publication.
  2. Harold W. Kuhn, "Variants of the Hungarian method for assignment problems", Naval Research Logistics Quarterly, 3: 253–258, 1956.
  3. Шаблон:Cite web
  4. J. Munkres, "Algorithms for the Assignment and Transportation Problems", Journal of the Society for Industrial and Applied Mathematics, 5(1):32–38, 1957 March.
  5. Шаблон:Cite journal
  6. Шаблон:Cite journal
  7. Шаблон:Cite journal
  8. Шаблон:Cite web
  9. Шаблон:Cite web
  10. Шаблон:Cite web
  11. Kőnig's theorem (graph theory) Konig's theorem
  12. Vertex cover minimum vertex cover
  13. Matching (graph theory) matching